<template>
  <div class="space-y-5 suspension" :style="{'top': percentage}">
    <nuxt-link
      v-if="isHelperMenuEnabled"
      to="/privacy-and-condition"
      class="suspension-item"
    >
      <font-awesome-icon
        icon="circle-question"
        class="text-[24px]"
      ></font-awesome-icon>
    </nuxt-link>
    <!-- <div class="suspension-item" onclick="javascript:void(Tawk_API.toggle())">
      <i class="fa-solid fa-headset text-[24px]"></i>
    </div> -->
    <button class="suspension-item" @click="isDialogVisible = true">
      <font-awesome-icon
        icon="earth-asia"
        class="text-[24px]"
      ></font-awesome-icon>
    </button>
  </div>
  <div
    v-if="isScrollOver"
    @click="backToTop"
    class="back-top cursor-pointer"
  ></div>
  <el-dialog
    id="language-dialog"
    v-model="isDialogVisible"
    custom-class="language-dialog"
    width="416px"
  >
    <template #title>
      <div class="px-6 py-4 border-b rounded-t dark:border-gray-600">
        <h3 class="text-base font-semibold text-gray-900 lg:text-xl">
          {{ $t("language") }}
        </h3>
      </div>
    </template>
    <div>
      <ul class="my-4 space-y-3">
        <li v-for="lang in languageSetting" :key="lang.ISO">
          <button
            :class="{
              active: defaultLanguageForDisplay === lang.LanguageLocalName,
            }"
            class="language-item"
            @click="switchLanguage(lang.ISO)"
          >
            <img
              :src="handleImportImage(`icon/${lang.ISO}.svg`)"
              class="w-[35px]"
              loading="lazy"
            />
            <span class="flex-1 ml-3 whitespace-nowrap">{{
              lang.LanguageLocalName
            }}</span>
          </button>
        </li>
      </ul>
    </div>
  </el-dialog>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { useLanguageComponent } from "@/composables/useTheme";
import { store } from "~~/store";

export default defineComponent({
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    isScrollOver: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const helperMenus = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          props.themeProperties,
          "lfd1_helper_menu_"
        )
    );
    const isHelperMenuEnabled = helperMenus.value.some(
      (menu) => !menu.IsHidden
    );
    const isDialogVisible = ref(false);
    const { ...prop } = useLanguageComponent();
    const backToTop = () => {
      window.scrollTo({ top: 0, behavior: "smooth" });
    };
    const percentage = ref('50%');
    const { getContactList } = useContactUs();
    if(getContactList.value.length) percentage.value = '35%';
    return {
      isHelperMenuEnabled,
      isDialogVisible,
      handleImportImage: commonHelper.handleImportCommonImage,
      ...prop,
      backToTop,
      percentage,
    };
  },
});
</script>

<style>
.language-dialog.el-dialog {
  margin: 2% auto 50px;
  border-radius: 0.45rem !important;
  background: #fff;
}
.language-dialog.el-dialog__body {
  padding-top: 0.5rem;
  padding-bottom: 0.5rem;
}
</style>
<style scoped>
.suspension {
  position: fixed;
  margin: auto;
  right: 8px;
  z-index: 99;
  font-size: 25px;
  border: none;
  outline: none;
  width: 55px;
  height: 200px;
}

.suspension-item {
  cursor: pointer;
  width: 100%;
  height: 55px;
  border-radius: 50%;
  border: 2px solid white;
  background: radial-gradient(#e9f0fe, #ffffff);
  display: flex;
  justify-content: center;
  align-items: center;
  box-shadow: rgba(100, 100, 111, 0.2) 0px 7px 29px 0px;
}

.suspension-item:hover {
  background: radial-gradient(#8fb9ff, #4c8efc);
  border: unset;
}

.suspension-item:hover > svg {
  color: white;
}

.language-item:hover,
.language-item.active {
  background: radial-gradient(#4c8efc, #4c8efc);
}

.language-item:hover span,
.language-item.active span {
  color: white;
}
</style>
<style lang="postcss" scoped>
.language-item {
  @apply flex w-full text-left items-center p-3 text-base font-bold rounded-lg bg-gray-50 hover:bg-gray-100 hover:shadow;
}
</style>
